#COM_Port = 1 ;  COM .      

Procedure Select_ComPort()      
     Protected Port.s, Text.s, Color      
        
     If IsSerialPort(#COM_Port)   ;      .      
       CloseSerialPort(#COM_Port) ;  .      
     EndIf      
        
     Port = GetGadgetText(3)      
     If OpenSerialPort(#COM_Port, Port, 19200, #PB_SerialPort_NoParity, 8, 1, #PB_SerialPort_NoHandshake, 255, 255)      
       Text=" "+Port+" " : Color=RGB(46, 137, 36)      
     Else      
       Text="    "+Port : Color=RGB(255,0,0)      
     EndIf      
        
     SetGadgetText(5, Text)        
     SetGadgetColor(5, #PB_Gadget_FrontColor, Color)      
        
EndProcedure      

Procedure InData() ;  .      
     Protected InBytes      
        
     If IsSerialPort(#COM_Port)   ;     .      
       InBytes = AvailableSerialPortInput(#COM_Port)      
       If InBytes>0 ;  .      
         Protected Dim InBuffer.a(InBytes), RealInBytes      
            
         RealInBytes = ReadSerialPortData(#COM_Port, @InBuffer(), 4)      ; InBytes   4 
         If RealInBytes>0      
           AddGadgetItem(4, -1, PeekS(@InBuffer(), RealInBytes, #PB_Ascii))      
         EndIf      
            
       EndIf      
     EndIf      
EndProcedure      

Procedure ComOut(Send_data.s)             ;    .    
      
      If IsSerialPort(#COM_Port)      ;      
        WriteSerialPortData(#COM_Port,@send_data,4)  ;      Out      
      Else    
       ;    .    
       MessageRequester("","   !",16)    
     EndIf    
        
EndProcedure    

If OpenWindow(0, 300, 100, 420, 370, "COM   SHT21")        
     ButtonGadget(1, 90, 300, 100, 45, " ", #PB_Button_MultiLine)          
     TextGadget(2,10,310,25,15,"") ;     "".        
     ComboBoxGadget(3, 10, 325, 70, 21, #PB_ComboBox_Editable)        
     For i=1 To 99          
       AddGadgetItem(3,-1,"COM"+Str(i))          
     Next i      
        
     SetGadgetState(3,0);      .       
     EditorGadget(4, 8,  10, 305, 280,#PB_String_ReadOnly)      
     TextGadget(5,10,350,200,15,"")                             ;     .        
     ButtonGadget(6, 200, 300, 100, 45, "   ", #PB_Button_MultiLine)      
     
     ButtonGadget(9, 310, 300, 100, 45, "   ", #PB_Button_MultiLine)   
     
     Select_ComPort()      
        
     Repeat        
          
       Event = WaitWindowEvent()        
          
       InData()                       ;   UART      
          
       If Event=#PB_Event_Gadget    ;       
         Gadget = EventGadget ( )   ;            
         If Gadget=1                      ;            
           ComOut("2101")                    ;    .    
           InData()      
         ElseIf Gadget=3                    ;              
           ComboBox.s=GetGadgetText(3) ;       .        
           ;   ,      .          
           Select_ComPort()      
                      
         ElseIf Gadget=6                 ;        
           ComOut("2102")                    ;    .    
           InData() 
           
          ElseIf Gadget=9                 ;        
           ComOut("2103")                    ;    .    
           OpenFile(0, "SHT.log")   
           FileSeek(0, Lof(0))
           InData()
            ; WriteData(0, RealInBytes , 255)                      ;    .
             WriteSerialPortData(#COM_Port, *Buffer, 255)

            FlushFileBuffers(0)
   CloseFile(0)
   
         EndIf        
       EndIf        

     
     Until Event=#PB_Event_CloseWindow           
        
   EndIf
   
Result =  CreateFile(0, "SHT.log")   


End   


; IDE Options = PureBasic 5.00 (Windows - x86)
; CursorPosition = 105
; FirstLine = 75
; Folding = -
; EnableAsm
; EnableXP
; UseIcon = Tt2.ico
; Executable = UART_control13.exe
; DisableDebugger
; CompileSourceDirectory
; Compiler = PureBasic 5.00 (Windows - x86)
; Debugger = Standalone
; Warnings = Display
; EnablePurifier